#ifndef	OLBTARGET_H
#define OLBTARGET_H

#include "resource.h"


// Forward class references
class CTargetTypePage;
class CTargetSheet;



class CTarget :	public k3dTransformObject,
								public k3dLocationServer

{
public:
	CTarget();
	~CTarget();

	CTargetSheet* m_Sheet;

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult EditObject();
	sdpResult ObjectRenamed(SDPCSTRING NewName);

	// k3dIOpenGLRender overrides
	sdpResult OpenGLRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine);

	// k3dIRiRender overrides

	// k3dILocationServer overrides

	// k3dITarget overrides

	// k3dIPersist overrides
	sdpResult Save(sdpXmlIElement* Element, k3dIDependencies* Dependencies);
	sdpResult Load(sdpXmlIElement* Element);
};







/////////////////////////////////////////////////////////////////////////////
// CTargetSheet

class CTargetSheet : public KSheet
{
public:
	CTargetSheet(CTarget* Target);
	~CTargetSheet();

	bool Create();
	void OnHelp();
	void OnTypeChange();


	CTarget* m_Object;
	CTargetTypePage* m_TargetTypePage;

	//{{AFX_VIRTUAL(CTargetSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CTargetSheet)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CTargetTypePage dialog

class CTargetTypePage : public KPage
{
public:
	CTargetTypePage(CTargetSheet* Parent);

	CTargetSheet* m_Sheet;

	//{{AFX_DATA(CTargetTypePage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CTargetTypePage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CTargetTypePage)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




