
#include "resource.h"



struct CGeometryFormatLWOBSurface {

	CString m_Name;
	gulong m_Fastgroup;
	k3dIMaterial* m_k3dIMaterial;
	k3dITexture* m_k3dITexture;

	};

#define LWFLAG_LUMINOUS	(1UL)
#define	LWFLAG_OUTLINE	(1UL << 1)
#define LWFLAG_SMOOTHING	(1UL << 2)
#define LWFLAG_COLORHIGHLIGHTS	(1UL << 3)
#define LWFLAG_COLORFILTER			(1UL << 4)
#define LWFLAG_OPAQUEEDGE				(1UL << 5)
#define LWFLAG_TRANSPARENTEDGE	(1UL << 6)
#define LWFLAG_SHARPTERMINATOR	(1UL << 7)
#define LWFLAG_DOUBLESIDED			(1UL << 8)
#define LWFLAG_ADDITIVE					(1UL << 9)
#define LWFLAG_SHADOWALPHA			(1UL << 10)





class CGeometryFormatLWOB : public k3dGeometryFilter
{
public:
	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIGeometryReadFormat overrides
	SDPCSTRING GetReadFilterString();
	sdpResult QueryCanRead(SDPCSTRING Filepath);
	sdpResult ReadFile(SDPCSTRING Filepath);

	// Helper functions for big-endian / little-endian format
	void ByteSwap(unsigned long*);
	void ByteSwap(float*);
	void ByteSwap(unsigned short*);
	void ByteSwap(short*);
};



/////////////////////////////////////////////////////////////////////////////
// CGeometryFormatLWOBNameDlg dialog

class CGeometryFormatLWOBNameDlg : public CDialog
{
public:
	CGeometryFormatLWOBNameDlg(CWnd* pParent = NULL);   // standard constructor

	//{{AFX_DATA(CGeometryFormatLWOBNameDlg)
	CString	m_Name;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CGeometryFormatLWOBNameDlg)
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CGeometryFormatLWOBNameDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

