function radians(degrees)
{
	return (degrees / 360.0) * 2 * Math.PI;
}

doc = Application.CreateDocument();
gear = doc.CreateObject("Mesh");
gear.Name = "Gear";

teeth = 20;
points = teeth * 4;
pointangle = 360 / points;

innerradius = 5;
outerradius = 5.75;

polygon = gear.Mesh.CreatePolygon();

for(i = 0; i < points; i++)
{
	angle = radians(i * pointangle);

	radius = (i % 4 < 2) ? innerradius : outerradius;

	point = gear.Mesh.CreatePoint();
	point.Location.Old = point.Location.Local = [radius * Math.cos(angle), radius * Math.sin(angle), 0];
	polygon.Points.AddPoint(point);
}

doc.RedrawAllViews();

