/** Name = Displacement Map **/
/** CreatedBy = Shead Data Processing **/

/** Km:Name = Amplitude **/
/** Km:HelpString = The amount of displacement **/

/** ZeroPoint:Name = Texture zero point **/
/** ZeroPoint:HelpString = The texture brightness value that produces no displacement **/

/** texturename:Name = Displacement Texture **/
/** texturename:HelpString = Select the texture to control displacement **/

/* Modified for use as a standard K-3D shader by Timothy M. Shead, tshead@k-3d.com */

displacement k3d_displacementmap(float Km = 1;
																 float ZeroPoint = 0.0;
																 string texturename = "";
	)
{
	point PP;
	point N1, N2;
	float Ct;

	if (texturename != "")
		Ct = float texture(texturename);
	else
		Ct = 0;

	N1 = calculatenormal(P);
	P = P - (Km * (Ct - ZeroPoint)) * normalize(N);
	N2 = calculatenormal(P);
	N = normalize(N) + normalize(N2) - normalize(N1);
}
