/** Name = ImageLayer **/
/** CreatedBy = Shead Data Processing **/

/** ObjectID = {58EA71C0-59FA-11d0-9C0D-444553540000} **/

/** screenleft:Show = false **/
/** screentop:Show = false **/
/** screenright:Show = false **/
/** screenbottom:Show = false **/

/** texturename:Name = Texture **/
/** texturename:HelpString = Texture to apply as the surface color **/


surface k3d_imagelayer(float screenleft = -1.0; float screenright = 1.0; float screentop = 1.0; float screenbottom = -1.0; float additive = 0.0;
											 string texturename = "")
{
	uniform float width = 1 / (screenright - screenleft);
	uniform float height = 1 / (screenbottom - screentop);

	point screenpoint = transform("screen", P);
	float x = (xcomp(screenpoint) - screenleft) * width;
	float y = (ycomp(screenpoint) - screentop) * height;

	color Ct;
	float Ot;

	if (texturename != "")
		{
			Ct = color texture(texturename, x, y);
			Ot = float texture(texturename[3], x, y);
		}
	else
		{
			Ct = 1;
			Ot = 1;
		}

	if (0.0 == additive)
		{
			Oi = Os * Ot;
		}
	else
		{
			Oi = 0.001;
		}

	Ci = Cs * Os * Ot * Ct;
}
