/** Name = ImageLayer Starfield **/
/** CreatedBy = Larry Gritz **/
/** History1 = Written by Larry Gritz, 1992 **/
/** History2 = Modified for use with K-3D by Shead Data Processing **/

/** ObjectID = {58EA71C0-59FA-11d0-9C0D-444553540000} **/

/** intensity:Name = Intensity **/
/** intensity:HelpString = Star intensity **/

/** pswidth:Name = Size **/
/** pswidth:HelpString = Star size **/

surface k3d_imagelayerstarfield(float intensity = 30.0; float pswidth = 0.38)
{
	point PP;
	float val;

	/* Shade in shader space */
	PP = transform("shader", P);

	/* Use a noise value, but only keep the "tips" of the blotches */
	val = smoothstep(1 - pswidth, 1, noise(PP));

	/* scale it by the intensity and sharpen it by squaring */
	Ci = intensity * val * val * val * val;
}
