/** Name = Warning Stripes **/
/** CreatedBy = Shead Data Processing **/
/** History1 = Created 2/28/98 **/

/** Frequency:Name = Stripe Frequency **/
/** Frequency:HelpString = Number of stripes across the surface **/

surface
k3d_warningstripes(uniform float Frequency = 12.0)
{
	uniform color black = color(0, 0, 0);

	color Ct;
	point Nf, V;
	float ss;

	ss = (s + t) * Frequency;

	ss = mod(floor(ss), 2.0);

	if (0.0 == ss)
		{
			Ct = Cs;
		}
	else
		{
			Ct = black;
		}

	/* diffuse reflection model */
	Nf = normalize(faceforward(N, I));
	V = normalize(-I);
	Oi = Os;
	Ci = (Os * Ct * (ambient() + diffuse(Nf)));
}
