#ifndef K3DIACTIONS_H
#define K3DIACTIONS_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIActions interface, which provides functionality for recording undo/redo -able "actions"
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>
#include <k3diactionclient.h>

class k3dIActions : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual sdpResult StartAction(SDPCSTRING Name) = 0;
	virtual sdpResult IsRecording() = 0;
	virtual sdpResult RecordStep(k3dIActionClient* Client, gulong OldValueCode, gulong OldValue, gulong OldValueSize, gulong NewValueCode, gulong NewValue, gulong NewValueSize) = 0;
	virtual sdpResult FinishAction() = 0;

	virtual gulong ActionCount() = 0;
	virtual gulong RedoCount() = 0;

	virtual sdpResult UndoAction() = 0;
	virtual sdpResult RedoAction() = 0;
};

#endif // K3DIACTIONS_H
