#ifndef K3DIBITMAPREADFORMAT_H
#define K3DIBITMAPREADFORMAT_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIBitmapReadFormat interface, which encapsulates the functionality for loading bitmap images
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class references
class k3dIFileFormat;
class k3dIBitmap;

class k3dIBitmapReadFormat : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual k3dIFileFormat* FileFormat() = 0;

	virtual sdpResult PreRead(k3dIBitmap* Bitmap, SDPCSTRING FilePath, SDPCSTRING Format, gulong* Width, gulong* Height) = 0;
	virtual sdpResult ReadOptions(k3dIBitmap* Bitmap, SDPCSTRING FilePath, SDPCSTRING Format) = 0;
	virtual sdpResult ReadFile(k3dIBitmap* Bitmap, SDPCSTRING FilePath, SDPCSTRING Format) = 0;
};

#endif // K3DIBITMAPREADFORMAT_H
