#ifndef K3DILOCATION_H
#define K3DILOCATION_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dILocation interface, implemented by objects that can act as a geometric point in the 3D workspace
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class declarations
class k3dIState;

class k3dILocation : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual k3dIState* State() = 0;
	virtual sdpResult GetOldXYZ(double Coords[3]) = 0;
	virtual sdpResult GetLocalXYZ(double Coords[3]) = 0;
	virtual sdpResult GetAnimXYZ(double Coords[3]) = 0;
	virtual sdpResult GetWorldXYZ(double Coords[3]) = 0;
	virtual sdpResult GetCameraXYZ(double Coords[3]) = 0;
	virtual sdpResult GetScreenXYZ(double Coords[3]) = 0;
	virtual sdpResult GetNormalXYZ(double Coords[3]) = 0;
	virtual sdpResult GetTextureXYZ(double Coords[3]) = 0;
	virtual sdpResult GetImplicitTextureXYZ(double Coords[3]) = 0;
	virtual sdpResult SetOldXYZ(double Coords[3]) = 0;
	virtual sdpResult SetLocalXYZ(double Coords[3]) = 0;
	virtual sdpResult SetAnimXYZ(double Coords[3]) = 0;
	virtual sdpResult SetWorldXYZ(double Coords[3]) = 0;
	virtual sdpResult SetCameraXYZ(double Coords[3]) = 0;
	virtual sdpResult SetScreenXYZ(double Coords[3]) = 0;
	virtual sdpResult SetNormalXYZ(double Coords[3]) = 0;
	virtual sdpResult SetTextureXYZ(double Coords[3]) = 0;
	virtual sdpResult SetImplicitTextureXYZ(double Coords[3]) = 0;
};

#endif // K3DILOCATION_H
