#ifndef K3DINTERFACES_H
#define K3DINTERFACES_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Includes all of the K-3D interfaces
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3diactionclient.h>	
#include <k3diactions.h>	
#include <k3dianimate.h>	
#include <k3diapplication.h>	
#include <k3dibitmap.h>	
#include <k3dibitmapreadformat.h>	
#include <k3dibitmapserver.h>	
#include <k3dibitmapwriteformat.h>	
#include <k3dicamera.h>	
#include <k3dichannel.h>	
#include <k3didependencies.h>	
#include <k3didocument.h>	
#include <k3dieditorengine.h>	
#include <k3dieditorlight.h>	
#include <k3dieditormaterial.h>	
#include <k3dieditorrender.h>	
#include <k3dieditortexture.h>	
#include <k3dieventclient.h>	
#include <k3difileformat.h>
#include <k3digeometryreadformat.h>	
#include <k3digeometrywriteformat.h>	
#include <k3diknot.h>	
#include <k3diknotserver.h>	
#include <k3dilayer.h>	
#include <k3dilight.h>	
#include <k3dilocation.h>	
#include <k3dilocationserver.h>	
#include <k3dimaterial.h>	
#include <k3dimaterialserver.h>	
#include <k3dimesh.h>	
#include <k3dinurbscurve.h>	
#include <k3dinurbscurveserver.h>	
#include <k3diobject.h>	
#include <k3diobjectcontext.h>	
#include <k3diobjectinfo.h>	
#include <k3diobjectlibrary.h>	
#include <k3dipersist.h>	
#include <k3dipoint.h>	
#include <k3dipointserver.h>	
#include <k3dipolygon.h>	
#include <k3dipolygonserver.h>	
#include <k3dipolypoint.h>	
#include <k3dipolypointserver.h>	
#include <k3direnderengine.h>	
#include <k3direnderfarm.h>	
#include <k3direnderframe.h>	
#include <k3direnderjob.h>	
#include <k3diriengine.h>	
#include <k3dirilight.h>	
#include <k3dirimaterial.h>	
#include <k3dirirender.h>	
#include <k3diritexture.h>	
#include <k3discriptengine.h>	
#include <k3dishaderinfo.h>	
#include <k3dishaderinfoargument.h>	
#include <k3displinechannel.h>	
#include <k3displinechannelnode.h>	
#include <k3displinechannelsegment.h>	
#include <k3distate.h>	
#include <k3ditarget.h>	
#include <k3ditexture.h>	
#include <k3ditextureserver.h>	
#include <k3ditimebase.h>	
#include <k3ditimeserver.h>	
#include <k3ditransform.h>	
#include <k3diusereventclient.h>	

#endif // K3DINTERFACES_H
