#ifndef K3DIRENDERENGINE_H
#define K3DIRENDERENGINE_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIRenderEngine interface, implemented by objects that can render graphics into a camera
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class declarations ...
class k3dICamera;
class k3dIRenderJob;
class k3dIRenderFrame;

class k3dIRenderEngine : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual sdpResult SetCamera(k3dICamera* Camera) = 0;
	virtual sdpResult Redraw() = 0;
	virtual sdpResult StartJob(k3dIRenderJob* Job) = 0;
	virtual sdpResult QueueFrame(k3dIRenderFrame* Frame) = 0;
	virtual sdpResult FinishJob(k3dIRenderJob* Job) = 0;
};

#endif // K3DIRENDERENGINE_H
