#ifndef K3DISCRIPTENGINE_H
#define K3DISCRIPTENGINE_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIScriptEngine interface, implemented by objects that can execute scripts written in a specific scripting language
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class declarations ...
class k3dIApplication;

class k3dIScriptEngine : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	/// Returns the language name associated with this engine
	virtual SDPCSTRING Language() = 0;
	/// Sets the controlling application for this engine
	virtual sdpResult SetOwner(k3dIApplication* Application) = 0;
	/// Executes a script
	virtual sdpResult Execute(SDPCSTRING Script) = 0;
};

#endif // K3DISCRIPTENGINE_H
