#ifndef K3DPRIMTOOLDIALOG_H
#define K3DPRIMTOOLDIALOG_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dPrimToolDialog class, which is a k3dDialog specialized for use with a k3dPrimTool-derived class
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3ddialog.h>

// Forward class declarations ...
class k3dPrimTool;

/////////////////////////////////////////////////////////////////////////
// k3dPrimToolDialog

class k3dPrimToolDialog : public k3dDialog
{
public:
	k3dPrimToolDialog();

	// UI creation ...
	bool Create(k3dPrimTool* Object, bool AutoDestroy, SDPCSTRING TemplateFile, SDPCSTRING HelpFile);

	// Data access ...
	k3dPrimTool* Object() { return m_Object; }

	// Built-in events ...
	virtual void OnOK();
	virtual void OnCancel();

protected:
	k3dPrimTool* m_Object;
};


#endif // K3DPRIMTOOLDIALOG_H
