// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements the k3dEditorRender class, which provides a default implementation of the k3dIEditorRender interface
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3deditorrender.h>
#include <sdpgl.h>

sdpResult k3dEditorRender::EditorPreRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPreRender()");

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorPushRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPushRender()");

	// Push attributes onto the stack ...
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	// Push a new set of matrices onto the stack ...
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorRender()");

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorPushChildRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPushChildRender()");

	// Push attributes onto the stack ...
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	// Push a new set of matrices onto the stack ...
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorPopChildRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPopChildRender()");

	// Pop old matrices off the stack ...
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	// Pop attributes off the stack ...
	glPopAttrib();

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorPopRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPopRender()");

	// Pop old matrices off the stack ...
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	// Pop attributes off the stack ...
	glPopAttrib();

	return SDP_S_OK;
}

sdpResult k3dEditorRender::EditorPostRender(k3dIEditorEngine* Engine)
{
	sdpglTrace("k3dEditorRender::EditorPostRender()");

	return SDP_S_OK;
}

