// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements the k3dTimeServer class, which provides a pluggable default implementation of k3dITimeServer
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dtimeserver.h>


k3dTimeServer::k3dTimeServer()
{
	m_CurrentTime = 0.0;
	m_DeltaTime = 0.1;
}


sdpResult k3dTimeServer::GetAnimTime(double* CurrentTime, double* DeltaTime)
{
	*CurrentTime = m_CurrentTime;
	*DeltaTime = m_DeltaTime;

	return SDP_S_OK;
}


sdpResult k3dTimeServer::SetAnimTime(double CurrentTime, double DeltaTime)
{
	m_CurrentTime = CurrentTime;
	m_DeltaTime = DeltaTime;

	return SDP_S_OK;
}
