// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements the k3dUserEventClient class, which provides a pluggable default implementation of k3dIUserEventClient
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dusereventclient.h>
#include <gdk/gdktypes.h>

k3dUserEventClient::k3dUserEventClient()
{
}

///////////////////////////////////////////////////////////////
// k3dIUserEventClient overrides

sdpResult k3dUserEventClient::OnMouseMove(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLButtonClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLButtonDoubleClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLButtonStartDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLButtonDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLButtonEndDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMButtonClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMButtonDoubleClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMButtonStartDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMButtonDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMButtonEndDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnRButtonClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnRButtonDoubleClick(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnRButtonStartDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnRButtonDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnRButtonEndDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLRButtonStartDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLRButtonDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnLRButtonEndDrag(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY, gdouble LastX, gdouble LastY, gdouble StartX, gdouble StartY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMouseWheelUp(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

sdpResult k3dUserEventClient::OnMouseWheelDown(k3dICamera* Camera, GdkModifierType Modifiers, gdouble CurrentX, gdouble CurrentY)
{
	return SDP_S_FALSE;
}

