#include "stdafx.h"
#include "tlbstats.h"
#include "toollib.h"





/////////////////////////////////////////////////////////////////////////////
// CStatsSizePage property page

CStatsSizePage::CStatsSizePage(CStatsSheet* Sheet)
	: KPage(IDD, Sheet, "StatsSize")
{
	//{{AFX_DATA_INIT(CStatsSizePage)
	//}}AFX_DATA_INIT

	m_Sheet = Sheet;
}





BEGIN_MESSAGE_MAP(CStatsSizePage, KPage)
	//{{AFX_MSG_MAP(CStatsSizePage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CStatsSizePage message handlers

BOOL CStatsSizePage::OnInitDialog()
{
	KPage::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




///////////////////////////////////////////////////////////////////
// CStats


CStats::CStats() : k3dTool()
{
	m_Sheet = NULL;
}


CStats::~CStats()
{
	if(m_Sheet)
		m_Sheet->DestroyWindow();
}


///////////////////////////////////////////////////////////////
// k3dIUnknown overrides

sdpResult CStats::QueryInterface(const sdpIID& InterfaceID, void** Interface)
{
	if(sdpSupportInterface<sdpIUnknown>(static_cast<k3dIObject*>(this), InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIObject>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIDocumentEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIUserEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIOpenGLRender>(this, InterfaceID, Interface)) return SDP_S_OK;

	return SDP_E_NO_INTERFACE;
}


gulong CStats::AddRef()
{
	return sdpComAddRef(m_ReferenceCount);
}


gulong CStats::Release()
{
	return sdpComRelease(this, m_ReferenceCount);
}




///////////////////////////////////////////////////////////////
// k3dIObject overrides

sdpResult CStats::SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context)
{
	if(sdpSucceeded(k3dTool::SetObjectContext(Server, Context)))
		{
			Context->State()->SetState(k3dIState::VISIBLE, true);
			return SDP_S_OK;
		}
	KFAIL(SDP_E_FAIL);
}


sdpResult CStats::EditObject()
{
	if(!KOpenDialog(m_Sheet, this)) KFAIL(SDP_E_FAIL);
	return SDP_S_OK;
}



///////////////////////////////////////////////////////////////
// k3dIOpenGLRender overrides

sdpResult CStats::OpenGLPostRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine)
{
	OnModify();
	return SDP_S_OK;
}


void CStatsSheet::OnHelp()
{
	m_Object->StandardHelp("tools", "stats.html");
}


/////////////////////////////////////////////////////////////////////////////
// CStats message handlers


void CStats::OnModify()
{
	sdpVector3 coords, min, max, size, center;
//	m_Document->GetSelectedDimensions(min, max, size, center);

	k3dSetDouble(k3dIChannel::DATA_DISTANCE, m_Sheet->m_SizePage->GetDlgItem(IDC_SIZEX)->m_hWnd, size[0]);
	k3dSetDouble(k3dIChannel::DATA_DISTANCE, m_Sheet->m_SizePage->GetDlgItem(IDC_SIZEY)->m_hWnd, size[1]);
	k3dSetDouble(k3dIChannel::DATA_DISTANCE, m_Sheet->m_SizePage->GetDlgItem(IDC_SIZEZ)->m_hWnd, size[2]);
}


////////////////////////////////////////////////////////////////////////////
// CStatsSheet

CStatsSheet::CStatsSheet(CStats* Object)
: KSheet(Object, theApp.m_hInstance, "Stats", VERTICAL, "Stats", TRUE)
{
	m_SizePage = NULL;
	m_Object = Object;
}


CStatsSheet::~CStatsSheet()
{
	m_Object->m_Sheet = NULL;
}


bool CStatsSheet::Create()
{
	m_SizePage = new CStatsSizePage(this);

	if(m_SizePage)
		{
			AddPage(m_SizePage);

			Create(IDD);
			return TRUE;
		}

	KFAIL(FALSE);
}


BEGIN_MESSAGE_MAP(CStatsSheet, KSheet)
	//{{AFX_MSG_MAP(CStatsSheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


