
#include "resource.h"

// Forward class references
class CStats;
class CStatsSheet;



/////////////////////////////////////////////////////////////////////////////
// CStatsPage dialog

class CStatsSizePage : public KPage
{
public:
	CStatsSizePage(CStatsSheet* Sheet);

	//{{AFX_DATA(CStatsPage)
	//}}AFX_DATA

	CStatsSheet* m_Sheet;

	//{{AFX_VIRTUAL(CStatsPage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CStatsPage)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////
// CStatsSheet

class CStatsSheet : public KSheet
{
public:
	CStatsSheet(CStats* Object);
	~CStatsSheet();

	bool Create();
	void OnHelp();

	CStats* m_Object;

	CStatsSizePage* m_SizePage;

	//{{AFX_DATA(CStatsSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CStatsSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CStatsSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




class CStats : public k3dTool,
							 public k3dOpenGLRender
{
public:
	CStats();
	~CStats();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context);
	sdpResult EditObject();

	// k3dIOpenGLRender overrides
	sdpResult OpenGLPostRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine);

	void OnModify();

	CStatsSheet* m_Sheet;
};


