
#include "resource.h"


// Forward declaration
class CBoolean;



/////////////////////////////////////////////////////////////////////////////
// CBooleanPage dialog

class CBooleanPage : public KPage
{
// Construction
public:
	CBooleanPage(CBoolean* Parent);

	void OnUpdateNumbers();

	CBoolean* m_Sheet;

	//{{AFX_DATA(CBooleanPage)
	//}}AFX_DATA

	//{{AFX_MSG(CBooleanPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnAadd();
	afx_msg void OnAdd();
	afx_msg void OnAnd();
	afx_msg void OnAremove();
	afx_msg void OnAremoveall();
	afx_msg void OnAselect();
	afx_msg void OnBadd();
	afx_msg void OnBremove();
	afx_msg void OnBremoveall();
	afx_msg void OnBselect();
	afx_msg void OnSubtract();
	afx_msg void OnXor();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};




class CBoolean : public k3dTool
{
public:
	CBoolean();
	~CBoolean();

	bool Create();
	void OnHelp();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	//k3dIObject overrides
	sdpResult EditObject();

	//k3dIDocumentEventClient overrides
	sdpResult OnPolygonsDeparting();

	CBooleanPage* m_BooleanPage;

	k3dBoundingBox3 m_APolysBBox;					// "A" polys bounding box
	k3dBoundingBox3 m_BPolysBBox;					// "B" polys bounding box
	k3dBoundingBox3 m_Intersection;				// top-level intersection

	class CPolygon
	{
	public:
		CPolygon(KHANDLE Handle) { m_Handle = Handle; };

		KHANDLE m_Handle;
		k3dBoundingBox3 m_BBox;
		sdpVector3 m_Normal;
		sdpVector3 m_Origin;
	};

	CList<CPolygon*, CPolygon*> m_APolys;	// "A" polys selected by user
	CList<CPolygon*, CPolygon*> m_BPolys;	// "B" polys selected by user
	CList<CPolygon*, CPolygon*> m_APolys1;	// "A" polys within top-level bbox
	CList<CPolygon*, CPolygon*> m_BPolys1;	// "B" polys within top-level bbox
	CList<CPolygon*, CPolygon*> m_APolys2;	// "A" polys that intersect "B" polys on individual level
	CList<CPolygon*, CPolygon*> m_BPolys2;	// "B" polys that intersect "A" polys on individual level


	k3dIPolygon* m_Polygon2;
	k3dIPoint* m_Point2;
	k3dILocation* m_PointLocation2;

	void OnAdd(CList<CPolygon*, CPolygon*>* List);
	void OnRemove(CList<CPolygon*, CPolygon*>* List);
	void OnRemoveAll(CList<CPolygon*, CPolygon*>* List);
	void OnSelect(CList<CPolygon*, CPolygon*>* List);
	void Intersect();
	void CalculateBoundingBox(CList<CPolygon*, CPolygon*>* Polys, k3dBoundingBox3* Result);
	void IntersectPolysWithBoundingBox(CList<CPolygon*, CPolygon*>* Polys, k3dBoundingBox3* Test, CList<CPolygon*, CPolygon*>* Result);
	void BBoxIntersectPolysWithPolys(CList<CPolygon*, CPolygon*>* APolys, CList<CPolygon*, CPolygon*>* BPolys, CList<CPolygon*, CPolygon*>* Result);
	void IntersectPolysWithPolys(CList<CPolygon*, CPolygon*>* APolys, CList<CPolygon*, CPolygon*>* BPolys);
	void IntersectPolyWithPoly(CPolygon*, CPolygon*);
	void CalculatePlaneEquations(CList<CPolygon*, CPolygon*>* Polys);

	//{{AFX_VIRTUAL(CBoolean)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBoolean)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};






