
#include "resource.h"

// Forward class references
class CBreakPoly;
class CBreakPolySheet;



/////////////////////////////////////////////////////////////////////////////
// CBreakPolyPage dialog

class CBreakPolyPage : public KPage
{
public:
	CBreakPolyPage(CBreakPolySheet* Sheet);

	CBreakPolySheet* m_Sheet;

	//{{AFX_DATA(CBreakPolyPage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBreakPolyPage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBreakPolyPage)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CBreakPolySheet

class CBreakPolySheet : public KPrimSheet
{
public:
	CBreakPolySheet(CBreakPoly* Object);
	~CBreakPolySheet();

	bool Create();
	void OnHelp();

	CBreakPoly* m_Object;

	CBreakPolyPage* m_BreakPolyPage;

	//{{AFX_DATA(CBreakPolySheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBreakPolySheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBreakPolySheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CBreakPoly

class CBreakPoly : public k3dPrimTool,
									 public k3dOpenGLRender
{
public:
	CBreakPoly();
	~CBreakPoly();

	k3dIPoint* m_Point1;
	k3dIPoint* m_Point2;
	k3dIPolygon* m_Polygon;

	void OnModify();
	void CreatePolygons();

	CBreakPolySheet* m_Sheet;

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context);
	sdpResult EditObject();

	//k3dIDocumentEventClient overrides
	sdpResult OnUndo(k3dIObject*);
	
	// k3dIUserEventClient overrides
	sdpResult OnLButtonClick(long, long, long);

	// k3dIOpenGLRender overrides
	sdpResult OpenGLRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine);

};


