#include "stdafx.h"
#include "tlbsubdivide.h"
#include "toollib.h"




CSubDividePage::CSubDividePage(CSubDivideSheet* Sheet)
	: KPage(IDD, Sheet, "Subdivide")
{
	//{{AFX_DATA_INIT(CSubDividePage)
	//}}AFX_DATA_INIT

	m_Sheet = Sheet;
}




BEGIN_MESSAGE_MAP(CSubDividePage, KPage)
	//{{AFX_MSG_MAP(CSubDividePage)
	ON_BN_CLICKED(IDC_ENABLEINTELLIGENCE, OnEnableintelligence)
	ON_BN_CLICKED(IDC_ENABLERECTANGLES, OnEnablerectangles)
	ON_BN_CLICKED(IDC_ENABLETRIANGLES, OnEnabletriangles)
	ON_EN_k3dILLFOCUS(IDC_MAXANGLE, OnKillfocusMaxangle)
	ON_CBN_SELCHANGE(IDC_RECTANGLETYPE, OnSelchangeRectangletype)
	ON_CBN_SELCHANGE(IDC_TRIANGLETYPE, OnSelchangeTriangletype)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSubDividePage message handlers


BOOL CSubDividePage::OnInitDialog()
{
	KPage::OnInitDialog();

	m_TriangleCombo.SubclassDlgItem(IDC_TRIANGLETYPE,this);

	m_TriangleCombo.AddString("Center (3)");
	m_TriangleCombo.AddString("Midpoints (3)");
	m_TriangleCombo.AddString("Midpoints + Center (4)");
	m_TriangleCombo.AddString("Bisect 1 & 2 (3)");
	m_TriangleCombo.AddString("Bisect 2 & 3 (3)");
	m_TriangleCombo.AddString("Bisect 3 & 1 (3)");

	m_TriangleCombo.SetCurSel(m_Sheet->m_Object->m_TriangleType);


	m_RectangleCombo.SubclassDlgItem(IDC_RECTANGLETYPE,this);

	m_RectangleCombo.AddString("Long Diagonal (3)");
	m_RectangleCombo.AddString("Short Diagonal (3)");
	m_RectangleCombo.AddString("Center (3)");
	m_RectangleCombo.AddString("Quadrangle (4)");
	m_RectangleCombo.AddString("Midpoints (3, 4)");
	m_RectangleCombo.AddString("Bisect 1 & 2 (3)");
	m_RectangleCombo.AddString("Bisect 2 & 3 (3)");
	m_RectangleCombo.AddString("Bisect 3 & 4 (3)");
	m_RectangleCombo.AddString("Bisect 4 & 1 (3)");
	m_RectangleCombo.AddString("Midpoints + Center (3)");
	m_RectangleCombo.AddString("Diagonals + Center (3)");
	m_RectangleCombo.AddString("Points 1 & 3 (3)");
	m_RectangleCombo.AddString("Points 2 & 4 (3)");

	m_RectangleCombo.SetCurSel(m_Sheet->m_Object->m_RectangleType);


	CheckDlgButton(IDC_ENABLEINTELLIGENCE, m_Sheet->m_Object->m_Intelligence);
	CheckDlgButton(IDC_ENABLERECTANGLES, m_Sheet->m_Object->m_Rectangles);
	CheckDlgButton(IDC_ENABLETRIANGLES, m_Sheet->m_Object->m_Triangles);
	k3dSetDouble(k3dIChannel::DATA_ANGLE, GetDlgItem(IDC_MAXANGLE)->m_hWnd, m_Sheet->m_Object->m_MaxAngle);

	if(m_Sheet->m_Object->m_Intelligence)
		{
			GetDlgItem(IDC_MAXANGLE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_MAXANGLE)->EnableWindow(FALSE);
		}

	if(m_Sheet->m_Object->m_Triangles)
		{
			GetDlgItem(IDC_TRIANGLETYPE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_TRIANGLETYPE)->EnableWindow(FALSE);
		}

	if(m_Sheet->m_Object->m_Rectangles)
		{
			GetDlgItem(IDC_RECTANGLETYPE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_RECTANGLETYPE)->EnableWindow(FALSE);
		}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CSubDividePage::OnEnableintelligence()
{
	m_Sheet->m_Object->m_Intelligence = IsDlgButtonChecked(IDC_ENABLEINTELLIGENCE) ? TRUE : FALSE;

	if(m_Sheet->m_Object->m_Intelligence)
		{
			GetDlgItem(IDC_MAXANGLE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_MAXANGLE)->EnableWindow(FALSE);
		}

	OnModify();
}


void CSubDividePage::OnEnablerectangles()
{
	m_Sheet->m_Object->m_Rectangles = IsDlgButtonChecked(IDC_ENABLERECTANGLES) ? TRUE : FALSE;

	if(m_Sheet->m_Object->m_Rectangles)
		{
			GetDlgItem(IDC_RECTANGLETYPE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_RECTANGLETYPE)->EnableWindow(FALSE);
		}

	OnModify();
}

void CSubDividePage::OnEnabletriangles()
{
	m_Sheet->m_Object->m_Triangles = IsDlgButtonChecked(IDC_ENABLETRIANGLES) ? TRUE : FALSE;

	if(m_Sheet->m_Object->m_Triangles)
		{
			GetDlgItem(IDC_TRIANGLETYPE)->EnableWindow(TRUE);
		}
	else
		{
			GetDlgItem(IDC_TRIANGLETYPE)->EnableWindow(FALSE);
		}

	OnModify();
}

void CSubDividePage::OnKillfocusMaxangle()
{
	// TODO: Add your control notification handler code here

	OnModify();
}


void CSubDividePage::OnSelchangeRectangletype()
{
	m_Sheet->m_Object->m_RectangleType = (CSubDivide::RectangleType)m_RectangleCombo.GetCurSel();
	OnModify();
}

void CSubDividePage::OnSelchangeTriangletype()
{
	m_Sheet->m_Object->m_TriangleType = (CSubDivide::TriangleType)m_TriangleCombo.GetCurSel();
	OnModify();
}




////////////////////////////////////////////////////////////////////////////
// CSubDivideSheet

CSubDivideSheet::CSubDivideSheet(CSubDivide* Object)
: KPrimSheet(Object, theApp.m_hInstance, "SubDivide", VERTICAL, "SubDivide", TRUE)
{
	m_SubDividePage = NULL;
	m_Object = Object;
}


CSubDivideSheet::~CSubDivideSheet()
{
	m_Object->m_Sheet = NULL;
}



bool CSubDivideSheet::Create()
{
	m_SubDividePage = new CSubDividePage(this);

	if(m_SubDividePage)
		{
			AddPage(m_SubDividePage);

			Create(IDD);
			return TRUE;
		}

	KFAIL(FALSE);
}


BEGIN_MESSAGE_MAP(CSubDivideSheet, KPrimSheet)
	//{{AFX_MSG_MAP(CSubDivideSheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




/////////////////////////////////////////////////////////////////////////////
// CSubDivide

CSubDivide::CSubDivide() : k3dPrimTool()
{
	m_Intelligence = FALSE;
	m_Rectangles = TRUE;
	m_Triangles = TRUE;
	m_MaxAngle = 0.0;

	m_TriangleType = TT_MIDPOINTS;
	m_RectangleType = RT_LONGDIAGONAL;
}



CSubDivide::~CSubDivide()
{
	if(m_Sheet)
		m_Sheet->DestroyWindow();
}




///////////////////////////////////////////////////////////////
// k3dIUnknown overrides

sdpResult CSubDivide::QueryInterface(const sdpIID& InterfaceID, void** Interface)
{
	if(sdpSupportInterface<sdpIUnknown>(static_cast<k3dIObject*>(this), InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIObject>(this, InterfaceID, Interface)) return SDP_S_OK;

	if(sdpSupportInterface<k3dIDocumentEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIUserEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	return SDP_E_NO_INTERFACE;
}


gulong CSubDivide::AddRef()
{
	return sdpComAddRef(m_ReferenceCount);
}


gulong CSubDivide::Release()
{
	return sdpComRelease(this, m_ReferenceCount);
}



///////////////////////////////////////////////////////////////
// k3dIObject overrides

sdpResult CSubDivide::EditObject()
{
	if(!KOpenDialog(m_Sheet, this)) KFAIL(SDP_E_FAIL);
	return SDP_S_OK;
}



void CSubDivideSheet::OnHelp()
{
	m_Object->StandardHelp("tools", "subdivide.html");
}



/////////////////////////////////////////////////////////////////////////////
// CSubDivide message handlers

void CSubDivide::OnModify()
{
	// Get rid of old geometry ...
	KillAll();

	// Calculate number of points / polys ...
	gulong numpolypoints;

	gulong numpolys = 0;
	gulong numpoints = 0;

	for(k3dIPolygon* poly = m_Document->GetFirstPolygon(); poly; poly = m_Document->GetNextPolygon(poly))
		{
			numpolypoints = poly->Points()->GetPointCount();

			if(m_Rectangles && numpolypoints == 4)
				{
					switch(m_RectangleType)
						{
							case RT_POINTS13: numpolys += 2; numpoints += 4; break;
							case RT_POINTS24: numpolys += 2; numpoints += 4; break;
							case RT_LONGDIAGONAL: numpolys += 2; numpoints += 4; break;
							case RT_SHORTDIAGONAL: numpolys += 2; numpoints += 4; break;
							case RT_CENTER: numpolys += 4; numpoints += 5; break;
							case RT_QUADRANGLE: numpolys += 4; numpoints += 9; break;
							case RT_MIDPOINTS: numpolys += 5; numpoints += 8; break;
							case RT_BISECT12: numpolys += 3; numpoints += 5; break;
							case RT_BISECT23: numpolys += 3; numpoints += 5; break;
							case RT_BISECT34: numpolys += 3; numpoints += 5; break;
							case RT_BISECT41: numpolys += 3; numpoints += 5; break;
							case RT_MIDCENTER: numpolys += 8; numpoints += 9; break;
							case RT_DIAGCENTER: numpolys += 8; numpoints += 9; break;
							default:
								g_assert(0);	// Unknown type!
								break;
						}
				}
			else if(m_Triangles && numpolypoints == 3)
				{
					switch(m_TriangleType)
						{
							case TT_CENTER: numpolys += 3; numpoints += 4; break;
							case TT_MIDPOINTS: numpolys += 4; numpoints += 6; break;
							case TT_MIDCENTER: numpolys += 3; numpoints += 7; break;
							case TT_BISECT12: numpolys += 2; numpoints += 4; break;
							case TT_BISECT23: numpolys += 2; numpoints += 4; break;
							case TT_BISECT31: numpolys += 2; numpoints += 4; break;
							default:
								g_assert(0);	// Unknown type!
								break;
						}
				}
/*EDIT
			else if(m_SubDividePage->m_NGons && numpolypoints > 4)
				{
					switch(m_SubDividePage->m_NGonType)
						{
							case NT_CENTER: numpolys += numpolypoints; numpoints += 1; break;
							case NT_MIDPOINTS: numpolys += (numpolypoints + 1); numpoints += numpolypoints; break;
							case NT_MIDCENTER: numpolys += (numpolypoints * 2); numpoints += numpolypoints + 1; break;
							default:
								g_assert(0);	// Unknown type!
								break;
						}
				}*/
		}


	// Setup geometry ...
	KillAll();
	k3dIGroup* group = CreateGroup("Subdivided Polygons", numpoints, numpolys);


	hr = m_PolygonMatchList2->SetFirstMatch();
	while(hr == SDP_S_OK)
		{
			numpolypoints = m_Polygon2->GetPointCount();

			if(m_Rectangles && numpolypoints == 4)
				{
					m_Polygon2->SetFirstPoint();
					points[0] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsa);
					m_Polygon2->SetNextPoint();
					points[1] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsb);
					m_Polygon2->SetNextPoint();
					points[2] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsc);
					m_Polygon2->SetNextPoint();
					points[3] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsd);

					length0 = (coordsa[0] - coordsc[0]) * (coordsa[0] - coordsc[0]) + (coordsa[1] - coordsc[1]) * (coordsa[1] - coordsc[1]) + (coordsa[2] - coordsc[2]) * (coordsa[2] - coordsc[2]);
					length1 = (coordsb[0] - coordsd[0]) * (coordsb[0] - coordsd[0]) + (coordsb[1] - coordsd[1]) * (coordsb[1] - coordsd[1]) + (coordsb[2] - coordsd[2]) * (coordsb[2] - coordsd[2]);

					switch(m_RectangleType)
						{
							case RT_POINTS13:
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								break;
							case RT_POINTS24:
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								break;
							case RT_LONGDIAGONAL:
								if(length0 >= length1)
									{
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
									}
								else
									{
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
									}
								break;
							case RT_SHORTDIAGONAL:
								if(length1 >= length0)
									{
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
									}
								else
									{
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[0]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
										m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
										m_GroupPolygon2->AttachPointAfter(points[1]);
										m_GroupPolygon2->AttachPointAfter(points[2]);
										m_GroupPolygon2->AttachPointAfter(points[3]);
									}
								break;
							case RT_CENTER:
								coords1[0] = (coordsa[0] + coordsb[0] + coordsc[0] + coordsd[0]) * 0.25;
								coords1[1] = (coordsa[1] + coordsb[1] + coordsc[1] + coordsd[1]) * 0.25;
								coords1[2] = (coordsa[2] + coordsb[2] + coordsc[2] + coordsd[2]) * 0.25;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case RT_QUADRANGLE:
								coords1[0] = (coordsa[0] + coordsb[0] + coordsc[0] + coordsd[0]) * 0.25;
								coords1[1] = (coordsa[1] + coordsb[1] + coordsc[1] + coordsd[1]) * 0.25;
								coords1[2] = (coordsa[2] + coordsb[2] + coordsc[2] + coordsd[2]) * 0.25;

								coords2[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords2[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords2[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords3[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords3[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords3[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords4[0] = (coordsc[0] + coordsd[0]) * 0.5;
								coords4[1] = (coordsc[1] + coordsd[1]) * 0.5;
								coords4[2] = (coordsc[2] + coordsd[2]) * 0.5;

								coords5[0] = (coordsd[0] + coordsa[0]) * 0.5;
								coords5[1] = (coordsd[1] + coordsa[1]) * 0.5;
								coords5[2] = (coordsd[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+3]);
								m_GroupPointLocation2->SetOldXYZ(coords4);
								m_GroupPointLocation2->SetLocalXYZ(coords4);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+4]);
								m_GroupPointLocation2->SetOldXYZ(coords5);
								m_GroupPointLocation2->SetLocalXYZ(coords5);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);

								pointindex += 5;

								break;
							case RT_MIDPOINTS:
								coords1[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords2[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords2[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords2[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords3[0] = (coordsc[0] + coordsd[0]) * 0.5;
								coords3[1] = (coordsc[1] + coordsd[1]) * 0.5;
								coords3[2] = (coordsc[2] + coordsd[2]) * 0.5;

								coords4[0] = (coordsd[0] + coordsa[0]) * 0.5;
								coords4[1] = (coordsd[1] + coordsa[1]) * 0.5;
								coords4[2] = (coordsd[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+3]);
								m_GroupPointLocation2->SetOldXYZ(coords4);
								m_GroupPointLocation2->SetLocalXYZ(coords4);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);

								pointindex += 4;

								break;
							case RT_BISECT12:
								coords1[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsb[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);


								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case RT_BISECT23:
								coords1[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords1[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords1[2] = (coordsb[2] + coordsc[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);


								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case RT_BISECT34:
								coords1[0] = (coordsc[0] + coordsd[0]) * 0.5;
								coords1[1] = (coordsc[1] + coordsd[1]) * 0.5;
								coords1[2] = (coordsc[2] + coordsd[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);


								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case RT_BISECT41:
								coords1[0] = (coordsa[0] + coordsd[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsd[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsd[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);


								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case RT_MIDCENTER:
								coords1[0] = (coordsa[0] + coordsb[0] + coordsc[0] + coordsd[0]) * 0.25;
								coords1[1] = (coordsa[1] + coordsb[1] + coordsc[1] + coordsd[1]) * 0.25;
								coords1[2] = (coordsa[2] + coordsb[2] + coordsc[2] + coordsd[2]) * 0.25;

								coords2[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords2[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords2[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords3[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords3[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords3[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords4[0] = (coordsc[0] + coordsd[0]) * 0.5;
								coords4[1] = (coordsc[1] + coordsd[1]) * 0.5;
								coords4[2] = (coordsc[2] + coordsd[2]) * 0.5;

								coords5[0] = (coordsd[0] + coordsa[0]) * 0.5;
								coords5[1] = (coordsd[1] + coordsa[1]) * 0.5;
								coords5[2] = (coordsd[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+3]);
								m_GroupPointLocation2->SetOldXYZ(coords4);
								m_GroupPointLocation2->SetLocalXYZ(coords4);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+4]);
								m_GroupPointLocation2->SetOldXYZ(coords5);
								m_GroupPointLocation2->SetLocalXYZ(coords5);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);

								pointindex += 5;

								break;
							case RT_DIAGCENTER:
								coords1[0] = (coordsa[0] + coordsb[0] + coordsc[0] + coordsd[0]) * 0.25;
								coords1[1] = (coordsa[1] + coordsb[1] + coordsc[1] + coordsd[1]) * 0.25;
								coords1[2] = (coordsa[2] + coordsb[2] + coordsc[2] + coordsd[2]) * 0.25;

								coords2[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords2[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords2[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords3[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords3[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords3[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords4[0] = (coordsc[0] + coordsd[0]) * 0.5;
								coords4[1] = (coordsc[1] + coordsd[1]) * 0.5;
								coords4[2] = (coordsc[2] + coordsd[2]) * 0.5;

								coords5[0] = (coordsd[0] + coordsa[0]) * 0.5;
								coords5[1] = (coordsd[1] + coordsa[1]) * 0.5;
								coords5[2] = (coordsd[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+3]);
								m_GroupPointLocation2->SetOldXYZ(coords4);
								m_GroupPointLocation2->SetLocalXYZ(coords4);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+4]);
								m_GroupPointLocation2->SetOldXYZ(coords5);
								m_GroupPointLocation2->SetLocalXYZ(coords5);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+4]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+3]);

								pointindex += 5;

								break;
							default:
								break;
						}
				}
			else if(m_Triangles && numpolypoints == 3)
				{
					m_Polygon2->SetFirstPoint();
					points[0] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsa);
					m_Polygon2->SetNextPoint();
					points[1] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsb);
					m_Polygon2->SetNextPoint();
					points[2] = m_Polygon2->GetPointHandle();
					m_PolygonLocation2->GetOldXYZ(coordsc);


					switch(m_TriangleType)
						{
							case TT_CENTER:
								coords1[0] = (coordsa[0] + coordsb[0] + coordsc[0]) * 0.3333333333333333;
								coords1[1] = (coordsa[1] + coordsb[1] + coordsc[1]) * 0.3333333333333333;
								coords1[2] = (coordsa[2] + coordsb[2] + coordsc[2]) * 0.3333333333333333;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);

								pointindex++;

								break;
							case TT_MIDPOINTS:
								coords1[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords2[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords2[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords2[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords3[0] = (coordsc[0] + coordsa[0]) * 0.5;
								coords3[1] = (coordsc[1] + coordsa[1]) * 0.5;
								coords3[2] = (coordsc[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex+2]);

								pointindex += 3;

								break;

							case TT_MIDCENTER:
								coords1[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsb[2]) * 0.5;

								coords2[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords2[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords2[2] = (coordsb[2] + coordsc[2]) * 0.5;

								coords3[0] = (coordsc[0] + coordsa[0]) * 0.5;
								coords3[1] = (coordsc[1] + coordsa[1]) * 0.5;
								coords3[2] = (coordsc[2] + coordsa[2]) * 0.5;

								coords4[0] = (coordsa[0] + coordsb[0] + coordsc[0]) * 0.3333333333333333;
								coords4[1] = (coordsa[1] + coordsb[1] + coordsc[1]) * 0.3333333333333333;
								coords4[2] = (coordsa[2] + coordsb[2] + coordsc[2]) * 0.3333333333333333;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+1]);
								m_GroupPointLocation2->SetOldXYZ(coords2);
								m_GroupPointLocation2->SetLocalXYZ(coords2);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+2]);
								m_GroupPointLocation2->SetOldXYZ(coords3);
								m_GroupPointLocation2->SetLocalXYZ(coords3);

								m_GroupPointList2->SetHandle(m_PointArray[pointindex+3]);
								m_GroupPointLocation2->SetOldXYZ(coords4);
								m_GroupPointLocation2->SetLocalXYZ(coords4);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 2]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 3]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 3]);
 								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex + 1]);


								pointindex += 4;
								break;

							case TT_BISECT12:
								coords1[0] = (coordsa[0] + coordsb[0]) * 0.5;
								coords1[1] = (coordsa[1] + coordsb[1]) * 0.5;
								coords1[2] = (coordsa[2] + coordsb[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[2]);

								pointindex++;

								break;
							case TT_BISECT23:
								coords1[0] = (coordsb[0] + coordsc[0]) * 0.5;
								coords1[1] = (coordsb[1] + coordsc[1]) * 0.5;
								coords1[2] = (coordsb[2] + coordsc[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[1]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[0]);

								pointindex++;

								break;
							case TT_BISECT31:
								coords1[0] = (coordsc[0] + coordsa[0]) * 0.5;
								coords1[1] = (coordsc[1] + coordsa[1]) * 0.5;
								coords1[2] = (coordsc[2] + coordsa[2]) * 0.5;

								m_GroupPointList2->SetHandle(m_PointArray[pointindex]);
								m_GroupPointLocation2->SetOldXYZ(coords1);
								m_GroupPointLocation2->SetLocalXYZ(coords1);

								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(points[0]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygonList2->SetHandle(m_PolygonArray[polyindex++]);
								m_GroupPolygon2->AttachPointAfter(points[2]);
								m_GroupPolygon2->AttachPointAfter(m_PointArray[pointindex]);
								m_GroupPolygon2->AttachPointAfter(points[1]);

								pointindex++;

								break;
							default:
								break;
						}
				}
			hr = m_PolygonMatchList2->SetNextMatch();
		}


	KUserObject::OnModify();

	if(m_Sheet)
		m_Sheet->UpdateNumbers();
}


