
// Forward class references
class CSubDivide;
class CSubDivideSheet;


/////////////////////////////////////////////////////////////////////////////
// CSubDividePage dialog

class CSubDividePage : public KPage
{
public:
	CSubDividePage(CSubDivideSheet* Sheet);

	//{{AFX_DATA(CSubDividePage)
	//}}AFX_DATA

	CSubDivideSheet* m_Sheet;

	CComboBox m_TriangleCombo;
	CComboBox m_RectangleCombo;

	//{{AFX_VIRTUAL(CSubDividePage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSubDividePage)
	afx_msg void OnEnableintelligence();
	afx_msg void OnEnablerectangles();
	afx_msg void OnEnabletriangles();
	afx_msg void OnKillfocusMaxangle();
	afx_msg void OnSelchangeRectangletype();
	afx_msg void OnSelchangeTriangletype();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CSubDivideSheet

class CSubDivideSheet : public KPrimSheet
{
public:
	CSubDivideSheet(CSubDivide* Object);
	~CSubDivideSheet();

	bool Create();
	void OnHelp();

	CSubDivide* m_Object;

	CSubDividePage* m_SubDividePage;

	//{{AFX_DATA(CSubDivideSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CSubDivideSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSubDivideSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




/////////////////////////////////////////////////////////////////////////////
// CSubDivide

class CSubDivide : public k3dPrimTool
{
public:
	CSubDivide();
	~CSubDivide();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult EditObject();

	void OnModify(bool SaveAction);

	typedef enum
	{
		TT_CENTER,
		TT_MIDPOINTS,
		TT_MIDCENTER,
		TT_BISECT12,
		TT_BISECT23,
		TT_BISECT31
	} TriangleType;


	typedef enum
	{
		RT_LONGDIAGONAL,
		RT_SHORTDIAGONAL,
		RT_CENTER,
		RT_QUADRANGLE,
		RT_MIDPOINTS,
		RT_BISECT12,
		RT_BISECT23,
		RT_BISECT34,
		RT_BISECT41,
		RT_MIDCENTER,
		RT_DIAGCENTER,
		RT_POINTS13,
		RT_POINTS24
	} RectangleType;

	bool	m_Intelligence;
	bool	m_Rectangles;
	bool	m_Triangles;
	double	m_MaxAngle;
	TriangleType m_TriangleType;
	RectangleType m_RectangleType;

	CSubDivideSheet* m_Sheet;
};



