#!/usr/bin/perl

=cut

A small program to sort those ids in the COM interface,
spits out the new sdpCLSID and sdpIID arrays.

=cut



my $comfile = shift;

die "File not found" unless open(FHD, "< $comfile");


my @sdpCLSIDs = ();
my @sdpIIDs = ();

while(<FHD>)
	{
		if($_ =~ /sdpCLSID +(\w+)/)
			{
				push(@sdpCLSIDs, $1);
			}
		if($_ =~ /sdpIID +(\w+)/)
			{
				push(@sdpIIDs, $1);
			}
	}


my $numbers;
my $i;

$i = 1;
foreach $id (sort @sdpCLSIDs)
	{
		$numbers = sprintf("0x%08x, 0x%08x, 0x%08x, 0x%08x", 1, 0, 0, $i);
		print "const sdpCLSID $id = { $numbers };\n" ;
		$i++;
	}

print "\n";

$i = 1;
foreach $id (sort @sdpIIDs)
	{
		$numbers = sprintf("0x%08x, 0x%08x, 0x%08x, 0x%08x", 1, 0, 0, $i);
		print "const sdpIID $id\::iid = { $numbers };\n" ;
		$i++;
	}


