# Compile "C" source ...
.SUFFIXES: .c .o
.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

# Compile "C++" source ...
.SUFFIXES: .cpp .o
.cpp.o:
	$(CXX) $(CXXFLAGS) -c $< -o $@

# Remove all compiled objects ...
.PHONY: clean
clean:
	rm -f $(OBJ) $(LIB) $(BIN)

# Remove all executables and libraries ...
.PHONY: cleanbinaries
cleanbinaries:
	rm -f $(LIB) $(BIN)

# Generate dependency data ...
.SUFFIXES: .d

.c.d:
	@echo -n "Calculating dependencies for $< ... "
	@file=$<; echo -n "$${file%.c}.o " > $@; echo -n "$${file%.c}.d: " >> $@; $(CC) $(CFLAGS) -M $< | sed -e 's/.*://' >> $@
	@echo "done"

.cpp.d:
	@echo -n "Calculating dependencies for $< ... "
	@file=$<; echo -n "$${file%.cpp}.o " > $@; echo -n "$${file%.cpp}.d: " >> $@; $(CXX) $(CXXFLAGS) -M $< | sed -e 's/.*://' >> $@
	@echo "done"

include $(addsuffix .d, $(basename $(SRC)))


