/* test.sl - Test shader for the sdpslparse Shading Language Parser.
 * Based on the Standard plastic surface for RenderMan Interface.
 * (c) Copyright 1988, Pixar.
 *
 * The RenderMan (R) Interface Procedures and RIB Protocol are:
 *     Copyright 1988, 1989, Pixar.  All rights reserved.
 * RenderMan (R) is a registered trademark of Pixar.
 */


light
parsertest (float Ka = 1;
         uniform float Kd = .5;
         varying float Ks = .5;
         float roughness = .1;
	 color specularcolor = 1;
	 color red = color "rgb" (.9, .1, .2);
	 point origin = "shader" (0, 0, 0);
	 vector direction = (0,0,1);
	 float matrix[16] = {1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1};
	 output varying float uv=0;
	 string __category="uvlight,waterlight")
{
    normal Nf = faceforward (normalize(N),I);
    Oi = Os;
    Ci = Os * ( Cs * (Ka*ambient() + Kd*diffuse(Nf)) +
		specularcolor * Ks*specular(Nf,-normalize(I),roughness));
}

