#ifndef SDPCOMPILER_H
#define SDPCOMPILER_H

// SDPTypes Library
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


/** \file
		\brief Identifies the user's compiler/platform and adjusts warnings, compile-time options, etc. to match
		\author Tim Shead (tshead@k-3d.com)
*/

//////////////////////////////////////////////////////////////////
// Compiler vendors

#if defined _MSC_VER					// Microsoft compiler
/// Compiler is Microsoft Visual C++
#define SDPMICROSOFT
#elif defined __BCPLUSPLUS__	// Borland compiler
/// Compiler is Borland
#define SDPBORLAND
#else												// Unknown compiler
#endif

//////////////////////////////////////////////////////////////////
// Operating systems

#if defined WIN32
/// Target platform is Win32
#define SDPWIN32
#else
/// Target platform is Unix
#define SDPUNIX
#endif

//////////////////////////////////////////////////////////////////
// Annoying warnings

#if defined SDPMICROSOFT			// Microsoft compiler

#pragma warning (disable: 4786) // "identifier was truncated to '255' characters in the browser information"

#elif defined SDPBORLAND			// Borland compiler

#else												// Unknown compiler

#endif

/////////////////////////////////////////////////////////////////////////////////////////////
// Export calling conventions for library entry-points

#if defined SDPMICROSOFT			// Microsoft compiler
#define sdpExport extern "C" __declspec(dllexport)
#elif defined SDPBORLAND			// Borland compiler
#define sdpExport extern "C" __declspec(dllexport)
#else												// Unknown compiler
#define sdpExport extern "C"
#endif

#endif SDPCOMPILER_H
