#ifndef SDPUSERDATA_H
#define SDPUSERDATA_H

// SDPTypes Library
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


/** \file
		\brief Declares the sdpUserData class which implements the sdpIUserData interface
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpstring.h>
#include <sdpiuserdata.h>
#include <map>

///////////////////////////////////////////////////////////////////////
// sdpUserData

/// Implements the sdpIUserData interface
class sdpUserData : public sdpIUserData
{
public:
	virtual ~sdpUserData() {}

	/// Assigns a value to a name
	sdpResult SetData(SDPCSTRING Name, SDPCSTRING Value);
	/// Returns the value associated with the given name
	SDPCSTRING GetData(SDPCSTRING Name) const;

protected:
	/// A collection of name-value pairs
	typedef std::map<sdpString, sdpString> UserData;
	typedef UserData::iterator UserDataIterator;
	typedef UserData::const_iterator ConstUserDataIterator;
	
	/// Stores the mapping of names-to-values
	UserData m_UserData;
};


#endif SDPUSERDATA_H
