#ifndef SDPUTILITY_H
#define SDPUTILITY_H

// SDPTypes Library
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


/** \file
		\brief Declares useful odds-and-ends
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpsimpletypes.h>

/// Portable, accurate method to suspend execution for the given amount of time ...
void sdpSleep(const gulong Milliseconds);

/// Returns true if the architecture is big endian
bool sdpBigEndian();
/// Returns true if the architecture is little endian
bool sdpLittleEndian();

#endif SDPUTILITY_H
