// SDPTypes Library
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements SDPCOM constants and IDs
		\author Timothy M. Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>
#include <sdpiuserdata.h>

const sdpResult SDP_S_OK = 0x00000000;
const sdpResult SDP_S_FALSE = 0x00000001;

const sdpResult SDP_E_FAIL = 0x80000001;
const sdpResult SDP_E_NO_INTERFACE = 0x80000002;
const sdpResult SDP_E_UNKNOWN_OBJECT = 0x80000003;
const sdpResult SDP_E_OUT_OF_MEMORY = 0x80000004;

const sdpGUID sdpGUIDNull(0x00000000, 0x00000000, 0x00000000, 0x00000000);
const sdpIID sdpIIDNull(0x00000000, 0x00000000, 0x00000000, 0x00000000);
const sdpCLSID sdpCLSIDNull(0x00000000, 0x00000000, 0x00000000, 0x00000000);

const sdpIID sdpIUnknown::iid(0x00000000, 0x00000000, 0x00000000, 0x00000001);
const sdpIID sdpIUserData::iid(0x00000000, 0x00000000, 0x00000000, 0x00000002);


