#ifndef SDPXMLSAX_H
#define SDPXMLSAX_H

#include <sdpstring.h>
#include <iostream>

/// Callback interface for an object that wishes to receive parsing events
class sdpXmlISAXHandler
{
public:
	virtual void StartDocument() = 0;
	virtual void EndDocument() = 0;
	virtual void ProcessingInstruction(SDPCSTRING Target, SDPCSTRING Data) = 0;
	virtual void StartElement(SDPCSTRING Name, const sdpStringArray& Attributes) = 0;
	virtual void EndElement() = 0;
	virtual void Characters(SDPCSTRING Text) = 0;
	virtual void CDATABlock(SDPCSTRING Value) = 0;
	virtual void Warning(SDPCSTRING Message) = 0;
	virtual void Error(SDPCSTRING Message) = 0;
	virtual void FatalError(SDPCSTRING Message) = 0;
};

/// Parses an XML document, returning data to the caller through the sdpXmlISAXHandler interface
bool sdpXmlParseFile(sdpXmlISAXHandler* Handler, SDPCSTRING FilePath);
/// Parses an XML document, returning data to the caller through the sdpXmlISAXHandler interface
bool sdpXmlParse(sdpXmlISAXHandler* Handler, std::istream& Stream, SDPCSTRING FilePath);

#endif // !SDPXMLSAX_H
